#---
# Excerpted from "Rails Test Prescriptions",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/nrtest for more book information.
#---
require 'spec_helper'

describe "status_reports/edit.html.erb" do
  before(:each) do
    @status_report = assign(:status_report, stub_model(StatusReport,
      :new_record? => false,
      :project => nil,
      :user => nil,
      :yesterday => "MyText",
      :today => "MyText"
    ))
  end

  it "renders the edit status_report form" do
    render

    rendered.should have_selector("form", :action => status_report_path(@status_report), :method => "post") do |form|
      form.should have_selector("input#status_report_project", :name => "status_report[project]")
      form.should have_selector("input#status_report_user", :name => "status_report[user]")
      form.should have_selector("textarea#status_report_yesterday", :name => "status_report[yesterday]")
      form.should have_selector("textarea#status_report_today", :name => "status_report[today]")
    end
  end
end
