#---
# Excerpted from "Rails Test Prescriptions",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/nrtest for more book information.
#---
class JasmineGenerator < Rails::Generator::Base
  def manifest
    record do |m|

      m.directory "public/javascripts"
      m.file "jasmine-example/src/Player.js", "public/javascripts/Player.js"
      m.file "jasmine-example/src/Song.js", "public/javascripts/Song.js"

      m.directory "spec/javascripts"
      m.file "jasmine-example/spec/PlayerSpec.js", "spec/javascripts/PlayerSpec.js"

      m.directory "spec/javascripts/helpers"
      m.file "jasmine-example/spec/SpecHelper.js", "spec/javascripts/helpers/SpecHelper.js"

      m.directory "spec/javascripts/support"
      m.file "spec/javascripts/support/jasmine_runner.rb", "spec/javascripts/support/jasmine_runner.rb"
      m.file "spec/javascripts/support/jasmine-rails.yml", "spec/javascripts/support/jasmine.yml"

      m.directory "lib/tasks"
      m.file "lib/tasks/jasmine.rake", "lib/tasks/jasmine.rake"

      m.readme "INSTALL"
    end
  end

  def file_name
    "create_blog"
  end

end