#---
# Excerpted from "Rails Test Prescriptions",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/nrtest for more book information.
#---
require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe StatusReportsController do
  describe "route generation" do
    it "maps #index" do
      route_for(:controller => "status_reports", :action => "index").should == "/status_reports"
    end

    it "maps #new" do
      route_for(:controller => "status_reports", :action => "new").should == "/status_reports/new"
    end

    it "maps #show" do
      route_for(:controller => "status_reports", :action => "show", :id => "1").should == "/status_reports/1"
    end

    it "maps #edit" do
      route_for(:controller => "status_reports", :action => "edit", :id => "1").should == "/status_reports/1/edit"
    end

    it "maps #create" do
      route_for(:controller => "status_reports", :action => "create").should == {:path => "/status_reports", :method => :post}
    end

    it "maps #update" do
      route_for(:controller => "status_reports", :action => "update", :id => "1").should == {:path =>"/status_reports/1", :method => :put}
    end

    it "maps #destroy" do
      route_for(:controller => "status_reports", :action => "destroy", :id => "1").should == {:path =>"/status_reports/1", :method => :delete}
    end
  end

  describe "route recognition" do
    it "generates params for #index" do
      params_from(:get, "/status_reports").should == {:controller => "status_reports", :action => "index"}
    end

    it "generates params for #new" do
      params_from(:get, "/status_reports/new").should == {:controller => "status_reports", :action => "new"}
    end

    it "generates params for #create" do
      params_from(:post, "/status_reports").should == {:controller => "status_reports", :action => "create"}
    end

    it "generates params for #show" do
      params_from(:get, "/status_reports/1").should == {:controller => "status_reports", :action => "show", :id => "1"}
    end

    it "generates params for #edit" do
      params_from(:get, "/status_reports/1/edit").should == {:controller => "status_reports", :action => "edit", :id => "1"}
    end

    it "generates params for #update" do
      params_from(:put, "/status_reports/1").should == {:controller => "status_reports", :action => "update", :id => "1"}
    end

    it "generates params for #destroy" do
      params_from(:delete, "/status_reports/1").should == {:controller => "status_reports", :action => "destroy", :id => "1"}
    end
  end
end
